﻿Type=Class
Version=2.71
@EndOfDesignText@
'Class module

'Very basic class for a seekbar which displays its value.
'Supports any range between minValue and maxValue

#Event: ValueChanged(Value As Int, UserChanged As Boolean)

Sub Class_Globals

	Private mSeekBar As SeekBar
	Private mLabel As Label
	
	Private mMinValue As Int = 0
	Private mMaxValue As Int = 100
	Private mSuffix As String = ""
	
	Private mCallback As Object
	Private mEventName As String
	Private mVisible As Boolean
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize2(TargetModule As Object, pPanel As Panel, pEvent As String, minValue As Int, maxValue As Int, suffix As String)

	mMinValue = minValue
	
	mCallback = TargetModule
	mEventName = pEvent
	mSuffix = suffix
	
	mSeekBar.Max = maxValue - mMinValue
	mLabel.Text = (mSeekBar.Value + mMinValue) & mSuffix
	
End Sub

Public Sub Initialize (TargetModule As Object, EventName As String)
    mCallback = TargetModule
    mEventName = EventName
	
	mMinValue = 0
	mSuffix = ""
End Sub

Sub setMinValue(minValue As Int)
	mMinValue = minValue
	mSeekBar.Max = mMaxValue - mMinValue
End Sub

Sub getMinValue As Int
	Return mMinValue
End Sub

Sub setMaxValue(maxValue As Int)
	mMaxValue = maxValue
	mSeekBar.Max = mMaxValue - mMinValue
End Sub

Sub getMaxValue As Int
	Return mMaxValue
End Sub

Sub setValue(Value As Int)
	mSeekBar.Value = Value - mMinValue
	mLabel.Text = Value & mSuffix
End Sub

Sub getValue As Int
	Return mSeekBar.Value + mMinValue
End Sub

Sub setVisible(Value As Boolean)
	mVisible = Value
	mLabel.Visible = Value
	mSeekBar.Visible = Value
End Sub

Sub getVisible As Boolean
	Return mVisible
End Sub

Public Sub DesignerCreateView(Base As Panel, Lbl As Label, Props As Map)
	mSeekBar.Initialize("mSeekBar")
	mLabel.Initialize("")
	
	Base.AddView(mSeekBar, 0, (Base.Height - 32dip) / 2, Base.Width * 0.8, 32dip) 
	Base.AddView(mLabel, Base.Width * 0.8, 0, Base.Width * 0.2, Base.Height)

    mLabel.TextSize = Lbl.TextSize
    mLabel.TextColor = Lbl.TextColor
    mLabel.Gravity = Lbl.Gravity
    mLabel.Text = Lbl.Text
    mLabel.Typeface = Lbl.Typeface

	mSeekBar.Max = mMaxValue - mMinValue
	mLabel.Text = (mSeekBar.Value + mMinValue) & mSuffix

End Sub

Sub mSeekBar_ValueChanged (Value As Int, UserChanged As Boolean)
	mLabel.Text = (mSeekBar.Value + mMinValue) & mSuffix
	
	If SubExists(mCallback, mEventName & "_ValueChanged") Then
		CallSub3(mCallback, mEventName & "_ValueChanged", Value, UserChanged)
	End If
End Sub

